unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ComCtrls, ExtCtrls,
  DB, IBCustomDataSet, IBQuery, IBDatabase,
  UnitV, Unit2, Unit3, Unit4, Unit5, Unit6, Unit7, Unit9 ;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    ComboBox1: TComboBox;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuDBset: TMenuItem;
    MnuDmy3: TMenuItem;
    mnuExit: TMenuItem;
    StatusBar1: TStatusBar;
    MnuDmy1: TMenuItem;
    mnuAddTable1: TMenuItem;
    mnuAddTable2: TMenuItem;
    MnuDmy2: TMenuItem;
    mnuPCnameSet: TMenuItem;
    mnuImage: TMenuItem;
    mnuImageNew: TMenuItem;
    mnuImageEdit: TMenuItem;
    mnuImageList: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuDBsetClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuAddTable1Click(Sender: TObject);
    procedure mnuAddTable2Click(Sender: TObject);
    procedure mnuPCnameSetClick(Sender: TObject);
    procedure mnuImageNewClick(Sender: TObject);
    procedure mnuImageEditClick(Sender: TObject);
    procedure mnuImageListClick(Sender: TObject);
  private
    { Private 錾 }
    DatFile : string ;  // f[^t@C
    procedure OpenDatFile(fn:string) ;
    procedure SaveDatFile(fn:string) ;
  public
    { Public 錾 }
    procedure DataBaseMaking ;
    procedure DataBaseConnect ;
    procedure DataBaseDisConnect ;
    function  DataTableCheck(t:string) : Boolean ;
    function  DataTableMaking1 : Boolean ;
    function  DataTableMaking2 : Boolean ;
    function  DataTableMaking3 : Boolean ;
    function  DataTableMaking4(t:string) : Boolean ;
    function  DataTableMaking(st:TStringList) : Boolean ;
    function  DataTableDelete(t:string) : Boolean ;
    function  TableAdd(t:string;Pn:integer;p1,p2:array of string) : Boolean ;
    function  TableAddS(t,p1,p2:string) : Boolean ;
    function  TableEdit(t:string;Pn:integer;p1,p2:array of string;wstr:string) : Boolean ;
    function  TableEditS(t,p,wstr:string) : Boolean ;
    function  TableDel(t,wstr:string) : Boolean ;
    procedure TableRefresh ;
    function  GetTableMaxRec(t,wstr:string) : Integer ;
    function  GetTableMaxField(t:string) : Integer ;
    function  CheckValue(t,pstr,wstr,val:string) : Boolean ; overload ;
    function  CheckValue(t,pstr,wstr:string;val:Integer) : Boolean ; overload ;
    function  GetTableData(plist,tlist,wstr:string;var p:array of string) : Integer ;
    function  GetTableData1(pstr,tlist,wstr:string;var p:string) : Integer ;
    function  TableRef(plist,tlist,wstr,ostr:string) : Integer ;
    function  GetMinValue(t,pstr,wstr:string) : string ;
    function  GetMaxValue(t,pstr,wstr:string) : string ;
    procedure GetTableField(var p:array of string) ;
    procedure TableFirst(var p:array of string) ;
    procedure TableLast(var p:array of string) ;
    procedure TableNext(var p:array of string) ;
    procedure TablePrior(var p:array of string) ;
    procedure TableMove(n:integer;var p:array of string) ;
    procedure TableClose ;
    function  TableSaveTXT(t,wstr,ostr,fn:string) : Boolean ;
    function  TableLoadTXT(t,fn:string;m1,m2:integer) : Boolean ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   DBserv := 'localhost:';
   DBfold := '';
   DBname := 'PAINT.FDB';
   PCno   := 0 ;
   PCname := '' ;
   Fm7_w  := 320 ;
   Fm7_h  := 240 ;
   for i:=0 to 6 do
      Fm7_c[i] := 64 ;
   Fm7_ph := 32 ;
   Fm8_w  := 320 ;
   Fm8_h  := 240 ;
   Fm8_f  := '' ;
   Fm8_pt := 0 ;
   Fm8_ps := 1 ;
   Fm8_pc := clBlack ;

   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, DBserv);
      ReadLn(F, DBfold);
      ReadLn(F, DBname);
      ReadLn(F, s);  PCno        := SInt(s) ;
      ReadLn(F, PCname);
      ReadLn(F, s);  Form1.Left  := SInt(s) ;
      ReadLn(F, s);  Form1.Top   := SInt(s) ;
      ReadLn(F, s);  Form1.Width := SInt(s) ;
      ReadLn(F, s);  Form1.Height:= SInt(s) ;
      ReadLn(F, s);  Form2.Left  := SInt(s) ;
      ReadLn(F, s);  Form2.Top   := SInt(s) ;
      ReadLn(F, s);  Form3.Left  := SInt(s) ;
      ReadLn(F, s);  Form3.Top   := SInt(s) ;
      ReadLn(F, s);  Form4.Left  := SInt(s) ;
      ReadLn(F, s);  Form4.Top   := SInt(s) ;
      ReadLn(F, s);  Form5.Left  := SInt(s) ;
      ReadLn(F, s);  Form5.Top   := SInt(s) ;
      ReadLn(F, s);  Fm7_w       := SInt(s) ;
      ReadLn(F, s);  Fm7_h       := SInt(s) ;
      if (Fm7_w < 80) then Fm7_w := 80 ;
      if (Fm7_h < 80) then Fm7_h := 80 ;
      for i:=0 to 6 do begin
         ReadLn(F, s);  Fm7_c[i] := SInt(s) ;
         if (Fm7_c[i] < 32) then
            Fm7_c[i] := 32 ;
      end;
      ReadLn(F, s);  Fm7_ph      := SInt(s) ;
      if (Fm7_ph < 10) then Fm7_ph := 10 ;
      ReadLn(F, s);  Fm8_w       := SInt(s) ;
      ReadLn(F, s);  Fm8_h       := SInt(s) ;
      ReadLn(F, Fm8_f);
      ReadLn(F, s);  Fm8_pt      := SInt(s) ;
      ReadLn(F, s);  Fm8_ps      := SInt(s) ;
      ReadLn(F, s);  Fm8_pc      := SInt(s) ;
      ReadLn(F, s);  Form9.Left  := SInt(s) ;
      ReadLn(F, s);  Form9.Top   := SInt(s) ;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
   i : integer ;
begin
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, DBserv);
      WriteLn(F, DBfold);
      WriteLn(F, DBname);
      s := IntToStr(PCno);          WriteLn(F, s);
      WriteLn(F, PCname);
      s := IntToStr(Form1.Left);    WriteLn(F, s);
      s := IntToStr(Form1.Top);     WriteLn(F, s);
      s := IntToStr(Form1.Width);   WriteLn(F, s);
      s := IntToStr(Form1.Height);  WriteLn(F, s);
      s := IntToStr(Form2.Left);    WriteLn(F, s);
      s := IntToStr(Form2.Top);     WriteLn(F, s);
      s := IntToStr(Form3.Left);    WriteLn(F, s);
      s := IntToStr(Form3.Top);     WriteLn(F, s);
      s := IntToStr(Form4.Left);    WriteLn(F, s);
      s := IntToStr(Form4.Top);     WriteLn(F, s);
      s := IntToStr(Form5.Left);    WriteLn(F, s);
      s := IntToStr(Form5.Top);     WriteLn(F, s);
      s := IntToStr(Fm7_w);         WriteLn(F, s);
      s := IntToStr(Fm7_h);         WriteLn(F, s);
      for i:=0 to 6 do begin
         s := IntToStr(Fm7_c[i]);   WriteLn(F, s);
      end;
      s := IntToStr(Fm7_ph);        WriteLn(F, s);
      s := IntToStr(Fm8_w);         WriteLn(F, s);
      s := IntToStr(Fm8_h);         WriteLn(F, s);
      WriteLn(F, Fm8_f);
      s := IntToStr(Fm8_pt);        WriteLn(F, s);
      s := IntToStr(Fm8_ps);        WriteLn(F, s);
      s := IntToStr(Fm8_pc);        WriteLn(F, s);
      s := IntToStr(Form9.Left);    WriteLn(F, s);
      s := IntToStr(Form9.Top);     WriteLn(F, s);

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// ---------- - ------------- - ----------

// f[^x[X쐬
procedure TForm1.DataBaseMaking ;
begin
   IBDataBase1.DatabaseName := DBserv + DBfold + DBNAME ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;
end;

// f[^x[Xɐڑ
procedure TForm1.DataBaseConnect ;
begin
   if (IBDatabase1.Connected) then exit ; // ɐڑ

   // f[^x[Xڑ
   IBDataBase1.DatabaseName := DBserv + DBfold + DBNAME ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   try
      IBDatabase1.Connected := True ;
   except
      // G[f[^x[Xؒf
      DataBaseDisConnect ;
   end;
end;

// f[^x[Xؒf
procedure TForm1.DataBaseDisConnect ;
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

// f[^e[ũ`FbN
//    t : e[u
function TForm1.DataTableCheck(t:string) : Boolean ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   ComboBox1.Items.Clear ;
   IBDatabase1.GetTableNames(ComboBox1.Items);
   if ComboBox1.Items.IndexOf(t) >= 0 then
      Result := True ;
end;

// f[^e[u TABLE1 쐬
function TForm1.DataTableMaking1 : Boolean ;
var
   st:TStringList ;
begin
   Result := False ;
   st := TStringList.Create ;
   try
      with st do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE1 + ' (' );
         Add('  N INTEGER NOT NULL UNIQUE,');
         Add('  SNAME VARCHAR(32)');
         Add('  );');
      end;
      Result := DataTableMaking(st);
   except
      ;
   end;
   st.Free ;
end;

// f[^e[u TABLE2 쐬
function TForm1.DataTableMaking2 : Boolean ;
var
   st:TStringList ;
begin
   Result := False ;
   st := TStringList.Create ;
   try
      with st do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE2 + ' (' );
         Add('  N  INTEGER NOT NULL UNIQUE,');
         Add('  SN INTEGER,');
         Add('  PNAME VARCHAR(16)');
         Add('  );');
      end;
      Result := DataTableMaking(st);
   except
      ;
   end;
   st.Free ;
end;

// f[^e[u TABLE3 쐬
function TForm1.DataTableMaking3 : Boolean ;
var
   st:TStringList ;
begin
   Result := False ;
   st := TStringList.Create ;
   try
      with st do begin
         Clear ;
         Add('CREATE TABLE ' + TABLE3 + ' (' );
         Add('  N  INTEGER NOT NULL UNIQUE,');
         Add('  MN    INTEGER,');
         Add('  INAME VARCHAR(64),');
         Add('  MEMO1 VARCHAR(80),');
         Add('  MEMO2 VARCHAR(80),');
         Add('  MEMO3 VARCHAR(80),');
         Add('  SX    INTEGER,');
         Add('  SY    INTEGER,');
         Add('  DATE1 VARCHAR(8),');
         Add('  DATE2 VARCHAR(8)');
         Add('  );');
      end;
      Result := DataTableMaking(st);
   except
      ;
   end;
   st.Free ;
end;

// f[^e[u TABLE4 쐬
function TForm1.DataTableMaking4(t:string) : Boolean ;
var
   st:TStringList ;
begin
   Result := False ;
   st := TStringList.Create ;
   try
      with st do begin
         Clear ;
         Add('CREATE TABLE ' + t + ' (' );
         Add('  N    INTEGER NOT NULL UNIQUE,');
         Add('  MN   INTEGER,');
         Add('  DN   INTEGER,');
         Add('  PTYP INTEGER,');
         Add('  PSIZ INTEGER,');
         Add('  PCOL INTEGER,');
         Add('  X    INTEGER,');
         Add('  Y    INTEGER');
         Add('  );');
      end;
      Result := DataTableMaking(st);
   except
      ;
   end;
   st.Free ;
end;

// f[^e[u쐬
//    st: CREATE(TStringListŐĂ鎖)
function TForm1.DataTableMaking(st:TStringList) : Boolean ;
var
   i,j : integer ;
begin
   Result := False ;
   j := st.Count ;
   if (j = 0) then exit ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         for i:=0 to j-1 do
            Add(st[i]);
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// f[^e[u폜
//    t : e[u
function TForm1.DataTableDelete(t:string) : Boolean ;
begin
   Result := False ;
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('DROP TABLE ' + t + ';' );
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[uւ̃f[^ǉ
//    t  : e[u
//    Pn : p[^
//    P1 : tB[h̔z
//    P2 : l̔z@f[^̏ꍇNULL΍^'`'͂@ĉ
function TForm1.TableAdd(t:string;Pn:integer;p1,p2:array of string) : Boolean ;
var
   s : string ;
   i : integer ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('INSERT INTO ' + t + ' (' );
         for i:=0 to Pn-1 do begin
            s := p1[i] ;
            if (i < (Pn-1)) then
               s := s + ',';
            Add('   ' + s );
         end;
         Add('   ) ');
         Add('   VALUES (');
         for i:=0 to Pn-1 do begin
            s := p2[i] ;
            if (i < (Pn-1)) then
               s := s + ',';
            Add('   ' + s );
         end;
         Add('   );');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;

   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[uւ̃f[^ǉ@ȈՃ^Cv
//    t  : e[u
//    P1 : tB[hXg@tB[hJ}ŋ؂Ă
//    P2 : lXg@lJ}ŋ؂Ă@f[^̏ꍇNULL΍^'`'͂@ĉ
function TForm1.TableAddS(t,p1,p2:string) : Boolean ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('INSERT INTO ' + t + ' (' );
         Add('   ' + p1 );
         Add('   ) ');
         Add('  VALUES (');
         Add('   ' + p2 );
         Add('   );');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;

   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[ũf[^C
//    t  : e[u
//    Pn : p[^
//    P1 : tB[h̔z
//    P2 : l̔z@f[^̏ꍇNULL΍^'`'͂@ĉ
//    wstr  : ͈/w(WHERE)
function TForm1.TableEdit(t:string;Pn:integer;p1,p2:array of string;wstr:string) : Boolean ;
var
   s : string ;
   i : integer ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('UPDATE ' + t + ' SET ' );
         for i:=0 to Pn-1 do begin
            s := p1[i] + '=' + p2[i] ;
            if (i < (Pn-1)) then
               s := s + ',';
            Add('   ' + s );
         end;
         if (wstr <> '') then
            Add('   WHERE ' + wstr);
         Add('   ;');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;

   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[ũf[^C@ȈՃ^Cv
//    t : e[u
//    P : tB[hƒl̃Xg
//      utB[h=lvJ}ŋ؂Ă
//       f[^̏ꍇNULL΍^'`'͂@ĉ
//    wstr : ͈/w(WHERE)
function TForm1.TableEditS(t,p,wstr:string) : Boolean ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('UPDATE ' + t + ' SET ' );
         Add('   ' + p );
         if (wstr <> '') then
            Add('   WHERE ' + wstr);
         Add('   ;');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;

   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[ũf[^s폜
//    t    : e[u
//    wstr : ͈/w(WHERE)
//           w肵Ȃꍇ͑Sf[^̂Œ
function TForm1.TableDel(t,wstr:string) : Boolean ;
var
   s : string ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         s := '' ;
         if (wstr <> '') then
            s := 'WHERE ' + wstr + ' ' ;
         Add('DELETE FROM ' + t + ' ' + s + ';');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      Result := True ;
   except
      IBTransaction1.Rollback ;
   end;

   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// f[^QƂ̍ۂ̃e[ũtbV
//    f[^e[uJĂԂ̏̏ꍇɂ͍sȂ
procedure TForm1.TableRefresh ;
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// e[u̍ő僌R[h擾
//    t    : e[u
//    wstr : ͈/w(WHERE)
//
// IBQuery1͕Ԃōso
// IBQuery1͕̂Œ
function TForm1.GetTableMaxRec(t,wstr:string) : Integer ;
var
   s : string ;
begin
   Result := -1 ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT * ' ;
      Add(s);
      s := '   FROM ' + t + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.Last ;
      Result := IBQuery1.RecordCount ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// ݂̃e[u̍őtB[h擾
//    t : e[u
//
// IBQuery1͕Ԃōso
// IBQuery1͕̂Œ
function TForm1.GetTableMaxField(t:string) : Integer ;
var
   s : string ;
begin
   Result := -1 ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT * ' ;
      Add(s);
      s := '   FROM ' + t + ' ;' ;
      Add(s);
   end;
   //
   try
      IBQuery1.Open ;
      Result := IBQuery1.Fields.Count ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// we[u̎w荀ڂ̒l邩ǂ`FbN
//    t    : e[u
//    pstr : ږ
//    wstr : ͈/w(WHERE)
//    val  : lij
//
// IBQuery1͕̂Œ
function TForm1.CheckValue(t,pstr,wstr,val:string) : Boolean ;
var
   s : string ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT ' + pstr + ' ' ;
      Add(s);
      s := '   FROM ' + t + ' ' ;
      Add(s);
      s := '   WHERE ' ;
      if (wstr <> '') then begin
         s := s + '(' + wstr + ') AND ' ;
      end;
      s := s + '(' + pstr + '=''' + val + ''') ' ;
      Add(s);
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      if not(IBQuery1.Eof) then
         Result := True ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// we[u̎w荀ڂ̒l邩ǂ`FbN
//    t    : e[u
//    pstr : ږ
//    wstr : ͈/w(WHERE)
//    val  : lilj
//
// IBQuery1͕̂Œ
function TForm1.CheckValue(t,pstr,wstr:string;val:Integer) : Boolean ;
var
   s : string ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT ' + pstr + ' ' ;
      Add(s);
      s := '   FROM ' + t + ' ' ;
      Add(s);
      s := '   WHERE ' ;
      if (wstr <> '') then begin
         s := s + '(' + wstr + ') AND ' ;
      end;
      s := s + '(' + pstr + '=' + IntToStr(val) + ') ' ;
      Add(s);
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      if not(IBQuery1.Eof) then
         Result := True ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// we[u̎w荀ڂ̍ŏl擾
//    t    : e[u
//    pstr : ږ
//    wstr : ͈/w(WHERE)
//
// IBQuery1͕̂Œ
function TForm1.GetMinValue(t,pstr,wstr:string) : string ;
var
   s : string ;
begin
   Result := '' ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT MIN(' + pstr + ') ' ;
      Add(s);
      s := '   FROM ' + t + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      Result := IBQuery1.Fields[0].AsString ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// we[u̎w荀ڂ̍ől擾
//    t    : e[u
//    pstr : ږ
//    wstr : ͈/w(WHERE)
//
// IBQuery1͕̂Œ
function TForm1.GetMaxValue(t,pstr,wstr:string) : string ;
var
   s : string ;
begin
   Result := '' ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT MAX(' + pstr + ') ' ;
      Add(s);
      s := '   FROM ' + t + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      Result := IBQuery1.Fields[0].AsString ;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// e[ûPf[^擾
//    plist : Xg@SĂ̏ꍇ́u*v
//    tlist : e[uXg
//    wstr  : ͈/w(WHERE) 1f[^m肷悤Ȏwsĉ
//    P[]   : (out)f[^e
// (ret)    : tB[h@-1:error
//
// IBQuery1͕̂Œ
function TForm1.GetTableData(plist,tlist,wstr:string;var p:array of string) : Integer ;
var
   s : string ;
   i,j : integer ;
begin
   Result := -1 ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT ' + plist + ' ' ;
      Add(s);
      s := '   FROM ' + tlist + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      if not(IBQuery1.Eof) then begin
         j := 0 ;
         try
            for i:=0 to IBQuery1.FieldCount-1 do begin
               P[i] := IBQuery1.Fields[i].AsString ;
               Inc(j) ;
            end;
         except
            ;
         end;
         Result := j ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// e[ûPf[^̂̂Pڂ擾
//    pstr  : 
//    tlist : e[uXg
//    wstr  : ͈/w(WHERE) 1f[^m肷悤Ȏwsĉ
//    p     : (out)̃f[^e
// (ret)    : 1:OK  0:NonData  -1:error
//
// IBQuery1͕̂Œ
function TForm1.GetTableData1(pstr,tlist,wstr:string;var p:string) : Integer ;
var
   s : string ;
   j : integer ;
begin
   Result := -1 ;
   p := '' ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT ' + pstr + ' ' ;
      Add(s);
      s := '   FROM ' + tlist + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   j := 0 ;
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      if not(IBQuery1.Eof) then begin
         try
            p := IBQuery1.Fields[0].AsString ;
            j := 1 ;
         except
            ;
         end;
         Result := j ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

// e[ũf[^Q
//    plist : Xg@SĂ̏ꍇ́u*v
//    tlist : e[uXg
//    wstr  : ͈/w(WHERE)
//    ostr  : ёւw(ORDER BY)~̏ꍇ͌"DESC"t鎖
//
// ̌Ƀf[^ǂݍނ̂ IBQuery1 closeĂȂ̂Œ
function TForm1.TableRef(plist,tlist,wstr,ostr:string) : Integer ;
var
   s : string ;
begin
   Result := 0 ;
   if not(IBDatabase1.Connected) then exit ;
   TableRefresh ;

   IBQuery1.Close;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      s := 'SELECT ' + plist + ' ' ;
      Add(s);
      s := '   FROM ' + tlist + ' ' ;
      Add(s);
      if (wstr <> '') then begin
         s := '   WHERE ' + wstr + ' ' ;
         Add(s);
      end;
      if (ostr <> '') then begin
         s := '   ORDER BY ' + ostr + ' ' ;
         Add(s);
      end;
      Add('   ;');
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.Last ;
      Result := IBQuery1.RecordCount ;
      IBQuery1.First ;
   except
      ;
   end;
end;

// ݂̃e[ũtB[h擾
//    p : (out)tB[h
//
// tB[hp̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.GetTableField(var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   for i:=0 to IBQuery1.FieldCount-1 do
      p[i] := IBQuery1.Fields[i].FieldName ;
end;

// e[u̍ŏ̃R[h
//    p : (out)f[^e
//
// f[^ep̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.TableFirst(var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   for i:=0 to IBQuery1.FieldCount-1 do
      p[i] := '' ;
   try
      IBQuery1.First ;
      for i:=0 to IBQuery1.FieldCount-1 do
         p[i] := IBQuery1.Fields[i].AsString ;
   except
      ;
   end;
end;

// e[u̍Ō̃R[h
//    p : (out)f[^e
//
// f[^ep̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.TableLast(var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   for i:=0 to IBQuery1.FieldCount-1 do
      p[i] := '' ;
   try
      IBQuery1.Last ;
      for i:=0 to IBQuery1.FieldCount-1 do
         p[i] := IBQuery1.Fields[i].AsString ;
   except
      ;
   end;
end;

// e[u̎̃R[h
//    p : (out)f[^e
//
// f[^ep̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.TableNext(var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   try
      IBQuery1.Next ;
      if not(IBQuery1.Eof) then begin
         for i:=0 to IBQuery1.FieldCount-1 do
            p[i] := IBQuery1.Fields[i].AsString ;
      end
      else begin
         for i:=0 to IBQuery1.FieldCount-1 do
            p[i] := '' ;
      end;
   except
      ;
   end;
end;

// e[u̒ÕR[h
//    p : (out)f[^e
//
// f[^ep̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.TablePrior(var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   try
      IBQuery1.Prior ;
      if not(IBQuery1.Bof) then begin
         for i:=0 to IBQuery1.FieldCount-1 do
            p[i] := IBQuery1.Fields[i].AsString ;
      end
      else begin
         for i:=0 to IBQuery1.FieldCount-1 do
            p[i] := '' ;
      end;
   except
      ;
   end;
end;

// e[u̒ÕR[h
//    n : ݃R[h牽R[hڂ邩w
//    p : (out)f[^e
//
// f[^ep̓Iz͗\ߊmۂĂ
// IBQuery1͊JԂł鎖
// IBDatabase1͊JԂł鎖O
procedure TForm1.TableMove(n:integer;var p:array of string) ;
var
   i : integer ;
begin
   if not(IBQuery1.Active) then exit;

   try
      IBQuery1.MoveBy(n) ;
      for i:=0 to IBQuery1.FieldCount-1 do
         p[i] := IBQuery1.Fields[i].AsString ;
   except
      ;
   end;
end;

// e[ủ{IIBQuery1
procedure TForm1.TableClose ;
begin
   IBQuery1.Active := False ;
end;

// f[^e[ueLXgt@CƂĕۑ
//    t    : e[u
//    wstr : ͈/w(WHERE)
//    ostr : ёւw(ORDER BY)~̏ꍇ͌"DESC"t鎖
//    fn   : t@C
//    ret  : True : OK  False : Error
function TForm1.TableSaveTXT(t,wstr,ostr,fn:string) : Boolean ;
var
   F : TextFile ;
   i,j,m,c : integer ;
   s : string ;
   ss : array of string ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(t)) then exit ;

   m := GetTableMaxRec(t,'') ;
   c := GetTableMaxField(t) ;
   TableRef('*',t,wstr,ostr);
   SetLength(ss,c);

	try
   	AssignFile(F, fn);
      Rewrite(F);
      // tB[h
      GetTableField(ss);
      s := '';
      for i:=0 to c-1 do begin
         s := s + ss[i] + #9 ;
      end;
      WriteLn(F, s);
      // f[^
      TableFirst(ss);
      for j:=1 to m do begin
         s := '';
         for i:=0 to c-1 do begin
            s := s + ss[i] + #9 ;
         end;
         WriteLn(F, s);
         TableNext(ss);
      end;
      TableClose ;

   	CloseFile(F);

      Result := True ;
   except
   	CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
	end;

   ss := nil;
end;

// f[^e[ueLXgt@CJ
//    TName : e[u
//    fn : t@C
//    m1 : 0:VK@1:ǉ
//    m2 : 0:̂܂ܑSēǍ@1:Psڂ͓ǂݔ΂
//    ret: True : OK  False : Error
function TForm1.TableLoadTXT(t,fn:string;m1,m2:integer) : Boolean ;
var
   F : TextFile ;
   s : string ;
   fs,ss: array of string ;
   ft  : array of Boolean ;   // True:  False:l
   c,n : integer ;
   i,j : integer ;
   fla : Boolean ;
begin
   Result := False ;
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(t)) then exit ;
   if not(FileExists(fn)) then exit ;

   SetLength(fs,300);   // ]T300Ƃ
   SetLength(ft,300);   // ]T300Ƃ
   SetLength(ss,300);   // ]T300Ƃ

   TableRef('*',t,'','');
   GetTableField(fs);
   c := IBQuery1.Fields.Count ;
   for i:=0 to c-1 do begin
      if (IBQuery1.Fields[i].DataType = ftString) then
         ft[i] := True
      else
         ft[i] := False ;
   end;
   TableClose ;

   if (m1 = 0) then begin
      // VK̏ꍇ͌݃f[^폜
      TableDel(t,'');
   end ;
   n := SInt(GetMaxValue(t,fs[0],''))+1 ; // ŏ̃tB[h͕KłƑO

	try
   	AssignFile(F, fn);
      FileMode := 0;
      Reset(F);
      if not(EOF(F)) then
         if (m2 <> 0) then
            ReadLn(F, s);

      while not(EOF(F)) do begin
         ReadLn(F, s);
         for i:=0 to c-1 do
            ss[i] := '' ;
         i := 0 ;
         fla := True ;
         while (fla) do begin
            j := AnsiPos(#9,s) ;
            if (j > 0) then begin
               ss[i] := Copy(s,1,j-1) ;
               s := Copy(s,j+1,Length(s));
               Inc(i);
               if (i >= 300) then fla := False ;
            end
            else begin
               ss[i] := s ;
               Inc(i);
               fla := False ;
            end;
         end;
         // f[^ǉ
         for i:=0 to c-1 do begin
            if (ft[i]) then begin
               if (ss[i] = '') then
                  ss[i] := 'NULL'
               else
                  ss[i] := '''' + ss[i] + '''' ;
            end
            else begin
               if (i = 0) then
                  ss[0] := IntToStr(n);
               ss[i] := FloatToStr(SDbl(ss[i]));
            end;
         end;
         TableAdd(t,c,fs,ss) ;
         Inc(n);
      end;

   	CloseFile(F);

      Result := True ;
   except
   	CloseFile(F);
	end;

   fs := nil ;
   ft := nil ;
   ss := nil ;
end;

// ---------- - ------------- - ----------

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // f[^t@ĆAvOt@C̊gqu.datvɂ
   DatFile := ChangeFileExt(Application.ExeName,'.dat') ;
   OpenDatFile(DatFile) ;
   // f[^x[Xڑ
   if (DBfold <> '') then begin
      DataBaseConnect ;
      if not(IBDatabase1.Connected) then begin
         DataBaseDisConnect ;    // ꉞ
         ShowMessage('f[^x[Xڑo܂BݒmFĉB');
      end;
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;
   //
   SaveDatFile(DatFile) ;
end;

// f[^x[Xݒ
procedure TForm1.mnuDBsetClick(Sender: TObject);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;

   Form2.ShowModal ;

   // f[^x[Xڑ
   DataBaseConnect ;
end;

// I
procedure TForm1.mnuExitClick(Sender: TObject);
begin
   close ;
end;

// iSECTIONj̓o^
procedure TForm1.mnuAddTable1Click(Sender: TObject);
begin
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(TABLE1)) then begin
      if not(DataTableMaking1) then exit ;
   end;

   Form3.ShowModal ;
end;

// o[iMEMBERj̓o^
procedure TForm1.mnuAddTable2Click(Sender: TObject);
begin
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(TABLE2)) then begin
      if not(DataTableMaking2) then exit ;
   end;

   Form4.ShowModal ;
end;

// PCpҖ̓o^
procedure TForm1.mnuPCnameSetClick(Sender: TObject);
begin
   if not(IBDatabase1.Connected) then exit ;

   Form5.ShowModal ;
end;

// 摜bVK쐬
procedure TForm1.mnuImageNewClick(Sender: TObject);
var
   fm : TForm6 ;
begin
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(TABLE3)) then begin
      if not(DataTableMaking3) then exit ;
   end;
   if (PCno = 0) then begin
      ShowMessage('PCpҖ̓o^sĉ');
      exit ;
   end;

   S_TYPE := 0 ;
   try
      fm := TForm6.Create(Application) ;
      fm.Caption := '摜ꗗf[^VK쐬';
      fm.Show ;
   except
      ;
   end;
end;

// 摜bҏW
procedure TForm1.mnuImageEditClick(Sender: TObject);
var
   fm : TForm6 ;
begin
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(TABLE3)) then exit ;
   if (PCno = 0) then begin
      ShowMessage('PCpҖ̓o^sĉ');
      exit ;
   end;

   S_TYPE := 1 ;
   S_CODE1:= 0 ;
   try
      fm := TForm6.Create(Application) ;
      fm.Caption := '摜ꗗf[^ҏW';
      fm.Show ;
   except
      ;
   end;
end;

// 摜bꗗ\
procedure TForm1.mnuImageListClick(Sender: TObject);
var
   fm : TForm7 ;
begin
   if not(IBDatabase1.Connected) then exit ;
   if not(DataTableCheck(TABLE3)) then begin
      if not(DataTableMaking3) then exit ;
   end;
   if (PCno = 0) then begin
      ShowMessage('PCpҖ̓o^sĉ');
      exit ;
   end;

   try
      fm := TForm7.Create(Application) ;
      fm.Show ;
   except
      ;
   end;
end;

end.
