unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls,  StdCtrls, ComCtrls,
  UnitV, Unit6, Unit8 ;

type
  TForm7 = class(TForm)
    Panel1: TPanel;
    SG1: TStringGrid;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Splitter1: TSplitter;
    Edit5: TEdit;
    LabelA: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    LabelB: TLabel;
    LabelC: TLabel;
    Button9: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure ComboBox2Select(Sender: TObject);
    procedure SG1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private 錾 }
    n,n1,n2 : integer ;
    wh1,od1 : string ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { Public 錾 }
  end;

var
  Form7: TForm7;

implementation

uses
   Unit1 ;

{$R *.dfm}

// J
procedure TForm7.FormShow(Sender: TObject);
var
   i : integer ;
begin
   Width  := Fm7_w ;
   Height := Fm7_h ;
   for i:=0 to 6 do
      SG1.ColWidths[i] := Fm7_c[i] ;
   Panel1.Height := Fm7_ph ;
   //
   n  := 100 ;    // 1y[W̃f[^
   n1 := 1 ;      // 擪R[hԍ
   n2 := 0 ;      // ł̃R[hԍ
   wh1:= '';      // WHERE߁ii荞ݗpj
   od1:= 'N';     // ORDER BYiяpj
   //
   with SG1 do begin
      Cells[0,0] := 'ԍ' ;
      Cells[1,0] := 'O' ;
      Cells[2,0] := 'P' ;
      Cells[3,0] := 'TCY' ;
      Cells[4,0] := 'cTCY' ;
      Cells[5,0] := '쐬t' ;
      Cells[6,0] := 'XVt' ;
      RowCount := n + 1;
   end;
   SCellClear ;
   Button4Click(Sender);   // [XV]
   Button1.SetFocus ;
end;

// 
procedure TForm7.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   Fm7_w := Width ;
   Fm7_h := Height ;
   for i:=0 to 6 do
      Fm7_c[i] := SG1.ColWidths[i] ;
   Fm7_ph := Panel1.Height ;

   Action := caFree ;
end;

// eNA
procedure TForm7.SCellClear ;
var
   i,j : integer ;
begin
   with SG1 do begin
      for j:=1 to RowCount-1 do
         for i:=0 to ColCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm7.SCellDisplay ;
var
   j : integer ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE3);
         if (wh1 <> '') then begin
            Add('  WHERE ' + wh1);
         end;
         Add('  ORDER BY ' + od1 + ';');
      end;
      j := 1 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         if (n1 > 1) then IBQuery1.MoveBy(n1-1);
         while not(IBQuery1.Eof) do begin
            SG1.Cells[0,j] := IBQuery1.FieldByName('N').AsString ;
            SG1.Cells[1,j] := IBQuery1.FieldByName('INAME').AsString ;
            SG1.Cells[2,j] := IBQuery1.FieldByName('MEMO1').AsString ;
            SG1.Cells[3,j] := IBQuery1.FieldByName('SX').AsString ;
            SG1.Cells[4,j] := IBQuery1.FieldByName('SY').AsString ;
            SG1.Cells[5,j] := IBQuery1.FieldByName('DATE1').AsString ;
            SG1.Cells[6,j] := IBQuery1.FieldByName('DATE2').AsString ;

            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
      except
         ;
      end;
      IBQuery1.Active := False ;
      n2 := n1 + j - 1;
   end;
end;

// ŏ
procedure TForm7.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 1 ;
   SCellDisplay ;
end;

// O
procedure TForm7.Button2Click(Sender: TObject);
begin
   SCellClear ;
   if (n1 > 1) then begin
      n1 := n1 - n ;
      if (n1 < 1) then n1 := 1 ;
   end;
   SCellDisplay ;
end;

// 
procedure TForm7.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm7.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

// яύX
procedure TForm7.ComboBox1Select(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox1.ItemIndex ;
   if (i = -1) then exit ;
   Case(i)of
    0:begin // ԍ
         od1 := 'N' ;
      end;
    1:begin // ԍ
         od1 := 'N DESC' ;
      end;
    2:begin // O
         od1 := 'INAME' ;
      end;
    3:begin // O
         od1 := 'INAME DESC' ;
      end;
    4:begin // P
         od1 := 'MEMO1,N' ;
      end;
    5:begin // P
         od1 := 'MEMO1 DESC,N DESC' ;
      end;
    6:begin // 쐬t
         od1 := 'DATE1,N' ;
      end;
    7:begin // 쐬t
         od1 := 'DATE1 DESC,N DESC' ;
      end;
    8:begin // XVt
         od1 := 'DATE2,N' ;
      end;
    9:begin // XVt
         od1 := 'DATE2 DESC,N DESC' ;
      end;
   end;

   Button1Click(Sender);   // ŏ
end;

// i荞
procedure TForm7.ComboBox2Select(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := ComboBox2.ItemIndex ;
   if (i = -1) then exit ;
   s := Edit1.Text ;
   if (s = '') then i := 0 ;
   Case(i)of
    0:begin // ij
         wh1 := '';
      end;
    1:begin // O
         wh1 := 'INAME' ;
      end;
    2:begin // P
         wh1 := 'MEMO1' ;
      end;
    3:begin // 쐬t
         wh1 := 'DATE1' ;
      end;
    4:begin // XVt
         wh1 := 'DATE2' ;
      end;
   end;

   if (wh1 <> '') then begin
      wh1 := wh1 + ' LIKE ''%' + s + '%''' ;
   end;
   Button1Click(Sender);   // ŏ
end;

// ZI
procedure TForm7.SG1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
   m,r : integer ;
   s : array of string ;
   w : string ;
begin
   Edit2.Text := '' ;
   Edit3.Text := '' ;
   Edit4.Text := '' ;
   Edit5.Text := '' ;
   LabelA.Caption := '쐬ҁF';
   LabelB.Caption := 'TCYF';
   LabelC.Caption := '@tF';

   r := SInt(SG1.Cells[0,ARow]) ;
   if (r <= 0) then exit ;

   SetLength(s ,TABLE3N);

   w := 'N=' + IntToStr(r) ;
   Form1.TableRef('*',TABLE3,w,'');
   Form1.TableFirst(s);
   Form1.TableClose ;

   Edit2.Text  := s[2];
   Edit3.Text  := s[3];
   Edit4.Text  := s[4];
   Edit5.Text  := s[5];
   LabelB.Caption := 'TCYF' + s[6] + '~' + s[7];
   LabelC.Caption := '@tF' + s[8] + '@' + s[9];

   m := SInt(s[1]) ;
   if (s[0] = '') then begin
      m := 0;
   end;

   s := nil ;

   // 쐬
   if (r > 0) then begin
      SetLength(s ,TABLE2N);
      w := 'N=' + IntToStr(m) ;
      Form1.TableRef('*',TABLE2,w,'');
      Form1.TableFirst(s);
      Form1.TableClose ;
      LabelA.Caption := '쐬ҁF'+s[2] ;
      s := nil ;
   end;
end;

// 
procedure TForm7.Button5Click(Sender: TObject);
begin
   Panel1.Height := 100 ;
end;

// 
procedure TForm7.Button6Click(Sender: TObject);
begin
   Panel1.Height := 28 ;
end;

// ҏW
procedure TForm7.Button7Click(Sender: TObject);
var
   n : integer ;
   fm : TForm6 ;
begin
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_TYPE := 1 ;
   S_CODE1:= n ;
   try
      fm := TForm6.Create(Application) ;
      fm.Caption := '摜ꗗf[^ҏW';
      fm.Show ;
   except
      ;
   end;
end;

// ڍ
procedure TForm7.Button8Click(Sender: TObject);
var
   n : integer ;
   fm : TForm8 ;
begin
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_CODE1 := n ;
   S_CODE2 := SInt(SG1.Cells[3,SG1.Row]) ;
   S_CODE3 := SInt(SG1.Cells[4,SG1.Row]) ;
   try
      fm := TForm8.Create(Application) ;
      fm.Caption := 'G`\tg | ' + SG1.Cells[1,SG1.Row] + '(N:' + IntToStr(n) + ')' ;
      fm.Show ;
   except
      ;
   end;
end;

// [摜f[^폜]
//    摜ꗗf[^if[^j͂̂܂܎c܂
procedure TForm7.Button9Click(Sender: TObject);
var
   i,n : integer ;
   t,s : string ;
begin
   i := SG1.Row ;
   n := SInt(SG1.Cells[0,i]) ;
   if (n <= 0) then exit ;
   t := TABLE4 + IntToStr(n) ;
   s := '摜f[^u' + SG1.Cells[1,i] + 'v(N:' + IntToStr(n) + ')' ;
   if not(Form1.DataTableCheck(t)) then begin
      ShowMessage(s + '̃e[uf[^݂͑܂B');
      exit ;
   end;

   if MessageDlg(s + '폜܂B낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;

   if (Form1.DataTableDelete(t)) then
      ShowMessage(s + '폜܂B')
   else
      ShowMessage(s + '폜o܂łB');
end;

end.
