unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, ComCtrls, ExtDlgs,
  UnitV, Unit9 ;

type
  TForm8 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SavePictureDialog1: TSavePictureDialog;
    ColorDialog1: TColorDialog;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    tbl : string ;   // 摜f[^e[u
    imgx,imgy : integer ;
    penType : integer ;
    penSize : integer ;
    penColor: integer ;
    penDrawMode : integer ;
    penFlag : Boolean ;
    penX0,penY0 : integer ;
    penX, penY  : array of integer ;
    penN : integer ;
    datN : integer ;
    procedure PenDraw(typ,siz,col,X,Y:integer) ;
  public
    { Public 錾 }
    P_CODE1 : integer ;    // IMGLIST̓o^ԍe[u
    P_CODE2 : integer ;    // 摜TCYSX
    P_CODE3 : integer ;    // 摜TCYSY
  end;

var
  Form8: TForm8;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm8.FormShow(Sender: TObject);
var
   i : integer ;
   s : array of string ;
begin
   P_CODE1:= S_CODE1;   // [h󂯓n
   P_CODE2:= S_CODE2;
   P_CODE3:= S_CODE3;

   Width  := Fm8_w ;
   Height := Fm8_h ;
   SavePictureDialog1.InitialDir := Fm8_f ;
   penType  := Fm8_pt ;
   penSize  := Fm8_ps ;
   penColor := Fm8_pc ;
   tbl  := TABLE4 + IntToStr(P_CODE1);
   imgx := P_CODE2 ;
   imgy := P_CODE3 ;

   penDrawMode := 0 ;
   penFlag := False ;
   penX0 := 0 ;
   penY0 := 0 ;
   penN  := 0 ;
   penX  := nil ;
   penY  := nil ;

   Image1.Picture := nil ;
   Image1.Width  := imgx ;
   Image1.Height := imgy ;
   GCLS(Image1.Canvas,imgx,imgy);

   datN := 0 ;
   // e[u邩ǂ`FbN΍쐬
   if not(Form1.DataTableCheck(tbl)) then begin
      Form1.DataTableMaking4(tbl) ;
   end
   else begin
      // f[^ꍇ͕`
      SetLength(s ,TABLE4N);
      datN := Form1.TableRef('*',tbl,'','N');
      for i:=1 to datN do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);

         PenDraw(SInt(s[3]),SInt(s[4]),SInt(s[5]),SInt(s[6]),SInt(s[7]));
      end;
      Form1.TableClose ;
      s := nil ;
   end;

   Timer1.Interval := TIMERWAIT ;
   Timer1.Enabled := True ;
end;

// I
procedure TForm8.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Timer1.Enabled := False ;
   penX  := nil ;
   penY  := nil ;
   Image1.Picture := nil ;
   Fm8_w  := Width ;
   Fm8_h  := Height ;
   Fm8_pt := penType ;
   Fm8_ps := penSize ;
   Fm8_pc := penColor ;

   Action := caFree ;
end;

// ۑ
procedure TForm8.SpeedButton1Click(Sender: TObject);
var
   fn : string ;
begin
   Timer1.Enabled := False ;

   if (SavePictureDialog1.Execute) then begin
      fn := SavePictureDialog1.FileName ;
      Fm8_f := ExtractFilePath(fn);
      if (AnsiUpperCase(ExtractFileExt(fn)) = '.BMP') then begin
         try
            Image1.Picture.SaveToFile(fn);
         except
            ;
         end;
      end;
   end;

   Timer1.Enabled := True ;
end;

// y
procedure TForm8.SpeedButton2Click(Sender: TObject);
begin
   Timer1.Enabled := False ;

   Form9.P_T := penType ;
   Form9.P_S := penSize ;
   Form9.ShowModal ;
   if (Form9.OKflag) then begin
      penType := Form9.P_T ;
      penSize := Form9.P_S ;
   end;

   Timer1.Enabled := True ;
end;

// yF
procedure TForm8.SpeedButton3Click(Sender: TObject);
begin
   Timer1.Enabled := False ;

   ColorDialog1.Color := penColor ;
   if (ColorDialog1.Execute) then begin
      penColor := ColorDialog1.Color ;
   end;

   Timer1.Enabled := True ;
end;

// y}Jn
procedure TForm8.SpeedButton4Click(Sender: TObject);
begin
   Timer1.Enabled := False ;

   SpeedButton4.Down := True ;
   penDrawMode := 1 ;

   Timer1.Enabled := True ;
end;

// }EX{^
procedure TForm8.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssLeft in Shift) then begin
      if (penDrawMode > 0) and (penFlag = False) then begin
         Timer1.Enabled := False ;

         PenDraw(penType,penSize,penColor,X,Y);
         penFlag := True ;
         penX0 := X ;
         penY0 := Y ;
         penN  := 1 ;
         SetLength(penX,penN);   penX[penN-1] := X;
         SetLength(penY,penN);   penY[penN-1] := Y;

         Timer1.Enabled := True ;
      end;
   end;
end;

// }EXړ
procedure TForm8.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if (ssLeft in Shift) then begin
      if (penDrawMode > 0) and (penFlag) then begin
         Timer1.Enabled := False ;

         PenDraw(penType,penSize,penColor,X,Y) ;
         if (X <> penX0)or(Y <> penY0) then begin
            Inc(penN) ;
            SetLength(penX,penN);   penX[penN-1] := X;
            SetLength(penY,penN);   penY[penN-1] := Y;
            penX0 := X ;
            penY0 := Y ;
         end;

         Timer1.Enabled := True ;
      end;
   end;
end;

// }s
procedure TForm8.PenDraw(typ,siz,col,X,Y:integer) ;
var
   s1,s2 : integer ;
begin
   s1 := siz div 2 ;
   s2 := siz - s1 ;
   with Image1.Canvas do begin
      if (siz = 1) then begin
         Pixels[X,Y] := col ;
         exit ;
      end;

      Pen.Mode := pmCopy ;
      Pen.Color := col ;
      Pen.Style := psSolid ;
      Brush.Color := col ;
      Case(typ)of
      0: begin // 
            Brush.Style := bsSolid ;
            Ellipse(X-s1,Y-s1, X+s2,Y+s2);
         end;
      1: begin // 
            Brush.Style := bsClear ;
            Ellipse(X-s1,Y-s1, X+s2,Y+s2);
         end;
      2: begin // 
            Brush.Style := bsSolid ;
            Rectangle(X-s1,Y-s1, X+s2,Y+s2);
         end;
      3: begin // 
            Brush.Style := bsClear ;
            Rectangle(X-s1,Y-s1, X+s2,Y+s2);
         end;
      4: begin // ^
            MoveTo(X+s2,Y-s1);
            LineTo(X-s1,Y+s2);
         end;
      5: begin // _
            MoveTo(X-s1,Y-s1);
            LineTo(X+s2,Y+s2);
         end;
      end;
   end;
end;

// }EX{^𗣂
procedure TForm8.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   fs: array of string ;
   s,ss : array of string ;
   n,dn,i,j : integer ;
   en: integer ;
begin
   Timer1.Enabled := False ;

   if (penDrawMode > 0) and (penFlag) then begin
      penFlag := False ;
      Screen.Cursor := crSQLWait ;
      // PCŕ`悳ĂȂǂ`FbN
      i := Form1.GetTableMaxRec(tbl,'') ;
      if (i > datN) then begin
         SetLength(ss ,TABLE4N);
         j := Form1.TableRef('*',tbl,'N>'+IntToStr(datN),'N');
         for i:=1 to j do begin
            if (i = 1) then
               Form1.TableFirst(ss)
            else
               Form1.TableNext(ss);
            PenDraw(SInt(ss[3]),SInt(ss[4]),SInt(ss[5]),SInt(ss[6]),SInt(ss[7]));
         end;
         Form1.TableClose ;
         ss := nil ;
         datN := datN + j;
      end;
      // f[^o^
      en := 0;
      if (penN > 0) then begin
         SetLength(fs,TABLE4N);
         SetLength(s ,TABLE4N);
         SetLength(ss,TABLE4N);
         fs[0] := 'N';
         fs[1] := 'MN';
         fs[2] := 'DN';
         fs[3] := 'PTYP';
         fs[4] := 'PSIZ';
         fs[5] := 'PCOL';
         fs[6] := 'X';
         fs[7] := 'Y';
         n  := SInt(Form1.GetMaxValue(tbl,'N',''))+1;
         dn := SInt(Form1.GetMaxValue(tbl,'DN','MN='+IntToStr(PCno)))+1;
         for i:=0 to penN-1 do begin
            s[0] := IntToStr(n) ;
            s[1] := IntToStr(PCno) ;
            s[2] := IntToStr(dn) ;
            s[3] := IntToStr(penType) ;
            s[4] := IntToStr(penSize) ;
            s[5] := IntToStr(penColor) ;
            s[6] := IntToStr(penX[i]) ;
            s[7] := IntToStr(penY[i]) ;
            while not(Form1.TableAdd(tbl,TABLE4N,fs,s)) do begin
               Inc(en);
               // G[PCŕ`恁ǂݍݕ`
               Form1.GetTableData('*',tbl,'N='+IntToStr(n),ss);
               PenDraw(SInt(ss[3]),SInt(ss[4]),SInt(ss[5]),SInt(ss[6]),SInt(ss[7]));
               // G[͔ԍZăgC
               Inc(n) ;
               s[0] := IntToStr(n) ;
            end;
            Inc(n);
         end;
         fs := nil ;
         s  := nil ;
         ss := nil ;
      end;
      datN := datN + penN + en ;
      penN  := 0 ;
      penX  := nil ;
      penY  := nil ;
      Screen.Cursor := crDefault ;
   end;

   Timer1.Enabled := True ;
end;

// ^C}[FXViPCŕ`悵e\j
procedure TForm8.Timer1Timer(Sender: TObject);
var
   ss : array of string ;
   i,j : integer ;
begin
   Timer1.Enabled := False ;

   // PCŕ`悳ĂȂǂ`FbN
   i := Form1.GetTableMaxRec(tbl,'') ;
   if (i > datN) then begin
      SetLength(ss ,TABLE4N);
      j := Form1.TableRef('*',tbl,'N>'+IntToStr(datN),'N');
      for i:=1 to j do begin
         if (i = 1) then
            Form1.TableFirst(ss)
         else
            Form1.TableNext(ss);
         PenDraw(SInt(ss[3]),SInt(ss[4]),SInt(ss[5]),SInt(ss[6]),SInt(ss[7]));
      end;
      Form1.TableClose ;
      ss := nil ;
      datN := datN + j;
   end;

   Timer1.Interval := TIMERWAIT ;
   Timer1.Enabled := True ;
end;

end.
